/*
  koi8u.c.  Produce a table of the "KOI8-U" Cyrillic character set.
  F. da Cruz, Columbia University, 1999.
*/
char *name[] = {
    "BOX DRAWINGS LIGHT HORIZONTAL",
    "BOX DRAWINGS LIGHT VERTICAL",
    "BOX DRAWINGS LIGHT DOWN AND RIGHT",
    "BOX DRAWINGS LIGHT DOWN AND LEFT",
    "BOX DRAWINGS LIGHT UP AND RIGHT",
    "BOX DRAWINGS LIGHT UP AND LEFT",
    "BOX DRAWINGS LIGHT VERTICAL AND RIGHT",
    "BOX DRAWINGS LIGHT VERTICAL AND LEFT",
    "BOX DRAWINGS LIGHT DOWN AND HORIZONTAL",
    "BOX DRAWINGS LIGHT UP AND HORIZONTAL",
    "BOX DRAWINGS LIGHT VERTICAL AND HORIZONTAL",
    "UPPER HALF BLOCK",
    "LOWER HALF BLOCK",
    "FULL BLOCK",
    "LEFT HALF BLOCK",
    "RIGHT HALF BLOCK",
    "LIGHT SHADE",
    "MEDIUM SHADE",
    "DARK SHADE",
    "TOP HALF INTEGRAL",
    "BLACK SQUARE",
    "BULLET OPERATOR",
    "SQUARE ROOT",
    "ALMOST EQUAL TO",
    "LESS THAN OR EQUAL TO",
    "GREATER THAN OR EQUAL TO",
    "NO-BREAK SPACE",
    "BOTTOM HALF INTEGRAL",
    "DEGREE SIGN",
    "SUPERSCRIPT TWO",
    "MIDDLE DOT",
    "DIVISION SIGN",
    "BOX DRAWINGS DOUBLE HORIZONTAL",
    "BOX DRAWINGS DOUBLE VERTICAL",
    "BOX DRAWINGS DOWN SINGLE AND RIGHT DOUBLE",
    "CYRILLIC SMALL LETTER IO",
    "CYRILLIC SMALL LETTER UKRAINIAN IE",
    "BOX DRAWINGS DOUBLE DOWN AND RIGHT",
    "CYRILLIC SMALL LETTER BYELORUSSIAN-UKRAINIAN I",
    "CYRILLIC SMALL LETTER YI (UKRAINIAN)",
    "BOX DRAWINGS DOUBLE DOWN AND LEFT",
    "BOX DRAWINGS UP SINGLE AND RIGHT DOUBLE",
    "BOX DRAWINGS UP DOUBLE AND RIGHT SINGLE",
    "BOX DRAWINGS DOUBLE UP AND RIGHT",
    "BOX DRAWINGS UP SINGLE AND LEFT DOUBLE",
    "CYRILLIC SMALL LETTER GHE WITH UPTURN",
    "BOX DRAWINGS DOUBLE UP AND LEFT",
    "BOX DRAWINGS VERTICAL SINGLE AND RIGHT DOUBLE",
    "BOX DRAWINGS VERTICAL DOUBLE AND RIGHT SINGLE",
    "BOX DRAWINGS DOUBLE VERTICAL AND RIGHT",
    "BOX DRAWINGS VERTICAL SINGLE AND LEFT DOUBLE",
    "CYRILLIC CAPITAL LETTER IO",
    "CYRILLIC CAPITAL LETTER UKRAINIAN IE",
    "BOX DRAWINGS DOUBLE VERTICAL AND LEFT",
    "CYRILLIC CAPITAL LETTER BYELORUSSIAN-UKRAINIAN I",
    "CYRILLIC CAPITAL LETTER YI (UKRAINIAN)",
    "BOX DRAWINGS DOUBLE DOWN AND HORIZONTAL",
    "BOX DRAWINGS UP SINGLE AND",
    "BOX DRAWINGS UP DOUBLE AND HORIZONTAL SINGLE",
    "BOX DRAWINGS DOUBLE UP AND HORIZONTAL",
    "BOX DRAWINGS VERTICAL SINGLE AND HORIZONTAL DOUBLE",
    "CYRILLIC CAPITAL LETTER GHE WITH UPTURN",
    "BOX DRAWINGS DOUBLE VERTICAL AND HORIZONTAL",
    "COPYRIGHT SIGN",
    "CYRILLIC SMALL LETTER YU",
    "CYRILLIC SMALL LETTER A",
    "CYRILLIC SMALL LETTER BE",
    "CYRILLIC SMALL LETTER TSE",
    "CYRILLIC SMALL LETTER DE",
    "CYRILLIC SMALL LETTER IE",
    "CYRILLIC SMALL LETTER EF",
    "CYRILLIC SMALL LETTER GHE",
    "CYRILLIC SMALL LETTER KHA",
    "CYRILLIC SMALL LETTER I",
    "CYRILLIC SMALL LETTER SHORT I",
    "CYRILLIC SMALL LETTER KA",
    "CYRILLIC SMALL LETTER EL",
    "CYRILLIC SMALL LETTER EM",
    "CYRILLIC SMALL LETTER EN",
    "CYRILLIC SMALL LETTER O",
    "CYRILLIC SMALL LETTER PE",
    "CYRILLIC SMALL LETTER YA",
    "CYRILLIC SMALL LETTER ER",
    "CYRILLIC SMALL LETTER ES",
    "CYRILLIC SMALL LETTER TE",
    "CYRILLIC SMALL LETTER U",
    "CYRILLIC SMALL LETTER ZHE",
    "CYRILLIC SMALL LETTER VE",
    "CYRILLIC SMALL LETTER SOFT SIGN",
    "CYRILLIC SMALL LETTER YERU",
    "CYRILLIC SMALL LETTER ZE",
    "CYRILLIC SMALL LETTER SHA",
    "CYRILLIC SMALL LETTER E",
    "CYRILLIC SMALL LETTER SHCHA",
    "CYRILLIC SMALL LETTER CHE",
    "CYRILLIC SMALL LETTER HARD SIGN",
    "CYRILLIC CAPITAL LETTER YU",
    "CYRILLIC CAPITAL LETTER A",
    "CYRILLIC CAPITAL LETTER BE",
    "CYRILLIC CAPITAL LETTER TSE",
    "CYRILLIC CAPITAL LETTER DE",
    "CYRILLIC CAPITAL LETTER IE",
    "CYRILLIC CAPITAL LETTER EF",
    "CYRILLIC CAPITAL LETTER GHE",
    "CYRILLIC CAPITAL LETTER KHA",
    "CYRILLIC CAPITAL LETTER I",
    "CYRILLIC CAPITAL LETTER SHORT I",
    "CYRILLIC CAPITAL LETTER KA",
    "CYRILLIC CAPITAL LETTER EL",
    "CYRILLIC CAPITAL LETTER EM",
    "CYRILLIC CAPITAL LETTER EN",
    "CYRILLIC CAPITAL LETTER O",
    "CYRILLIC CAPITAL LETTER PE",
    "CYRILLIC CAPITAL LETTER YA",
    "CYRILLIC CAPITAL LETTER ER",
    "CYRILLIC CAPITAL LETTER ES",
    "CYRILLIC CAPITAL LETTER TE",
    "CYRILLIC CAPITAL LETTER U",
    "CYRILLIC CAPITAL LETTER ZHE",
    "CYRILLIC CAPITAL LETTER VE",
    "CYRILLIC CAPITAL LETTER SOFT SIGN",
    "CYRILLIC CAPITAL LETTER YERU",
    "CYRILLIC CAPITAL LETTER ZE",
    "CYRILLIC CAPITAL LETTER SHA",
    "CYRILLIC CAPITAL LETTER E",
    "CYRILLIC CAPITAL LETTER SHCHA",
    "CYRILLIC CAPITAL LETTER CHE",
    "CYRILLIC CAPITAL LETTER HARD SIGN"
};

main() {
    int i, j;
    printf("KOI8-R (RFC 2319)\n");
    printf("char dec col/row oct hex  description\n");
    for (i = 128; i < 256; i++) {
	j = i - 128;
	printf("[%c]  %3d  %02d/%02d  %3o  %2X  %s\n",
	       i, i, i/16, i%16, i, i, name[j]);
    }
}
